package de.hftstuttgart.unifiedticketing.core;

import java.util.Objects;

public class TicketAssignee
{
    public final String email;
    public final String id;
    public final String fullName;
    public final String username;

    protected TicketAssignee(String email, String id, String username, String fullName)
    {
        this.email = email;
        this.id = id;
        this.fullName = fullName;
        this.username = username;
    }

    @Override
    public boolean equals(Object o)
    {
        if (this == o) return true;
        if (!(o instanceof TicketAssignee)) return false;
        TicketAssignee that = (TicketAssignee) o;
        return Objects.equals(id, that.id);
    }

    @Override
    public int hashCode()
    {
        return Objects.hash(id);
    }

    @Override
    public String toString()
    {
        return "TicketAssignee{" +
            "email='" + email + '\'' +
            ", id='" + id + '\'' +
            ", fullName='" + fullName + '\'' +
            ", username='" + username + '\'' +
            '}';
    }
}
